#ifndef _ACTION_H
#define _ACTION_H

#ifdef __cplusplus
extern "C" {
#endif

#include "stm32f4xx.h"
#include "motion_pages.h"

extern int64_t action_current_angles[PAGE_MAX_NUM_SERVOS];
extern uint8_t action_slope[PAGE_MAX_NUM_SERVOS];

// public functions
void action_init(uint16_t period_us);
inline void action_set_period(uint16_t period_us);
inline uint16_t action_get_period(void);
uint8_t action_load_page(uint8_t page_id);
void action_start_page(void);
void action_stop_page(void);
uint8_t action_is_running(void);
void action_enable_int(void);
void action_disable_int(void);
uint8_t action_is_int_enabled(void);
// operation functions
uint8_t action_in_range(unsigned short int address, unsigned short int length);
void action_process_read_cmd(unsigned short int address,unsigned short int length,unsigned char *data);
void action_process_write_cmd(unsigned short int address,unsigned short int length,unsigned char *data);
// motion manager interface
void action_process(void);

#ifdef __cplusplus
}
#endif

#endif
