#ifndef BIOLOID_GYRO_H
#define BIOLOID_GYRO_H

#ifdef __cplusplus
extern "C" {
#endif

#include "stm32f4xx.h"
#include "adc_dma.h"

/* public functions */
void gyro_init(void);
inline adc_ch_t gyro_get_fb_adc_channel(void);
inline adc_ch_t gyro_get_lr_adc_channel(void);
void gyro_calibrate(void);
inline void gyro_get_offsets(uint16_t *fb_offset,uint16_t *lr_offset);
// operation functions
uint8_t gyro_in_range(unsigned short int address, unsigned short int length);
void gyro_process_read_cmd(unsigned short int address,unsigned short int length,unsigned char *data);
void gyro_process_write_cmd(unsigned short int address,unsigned short int length,unsigned char *data);

#ifdef __cplusplus
}
#endif

#endif
