#ifndef _GPIO_H
#define _GPIO_H

#ifdef __cplusplus
extern "C" {
#endif

#include "stm32f4xx.h"

typedef enum {USER1_LED,USER2_LED,RXD_LED,TXD_LED} led_t;

typedef enum {USER_PB,RESET_PB,START_PB,MODE_PB} pushbutton_t;

void gpio_init(void);
// LED functions
void gpio_set_led(led_t led_id);
void gpio_clear_led(led_t led_id); 
void gpio_toggle_led(led_t led_id); 
void gpio_blink_led(led_t led_id, int16_t period_ms);
// Pushbuttons functions
uint8_t gpio_is_pushbutton_pressed(pushbutton_t pb_id);
void gpio_set_pushbutton_callback(pushbutton_t pb_id,void (*callback)(void));
// operation functions
uint8_t gpio_in_range(unsigned short int address,unsigned short int length);
void gpio_process_read_cmd(unsigned short int address,unsigned short int length,unsigned char *data);
void gpio_process_write_cmd(unsigned short int address,unsigned short int length,unsigned char *data);

#ifdef __cplusplus
}
#endif

#endif
